package baleine.client.main.view;

import baleine.client.main.model.TransItem;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;

public class CardShape extends StackPane {
	private TransItem relatedItem;
	private boolean isTranslated;

	private Text currentText;
	private Rectangle rect;

	private static final Color REGULAR_COLOR = Color.BURLYWOOD;
	private static final Color SECONDARY_COLOR = Color.CORNFLOWERBLUE;

	/**
	 * Constructor
	 * 
	 * @param item : related TransItem
	 */
	public CardShape(TransItem item) {
		relatedItem = item;
		isTranslated = false; // default value

		initHmi();
		new CardController().bind();
	}

	/**
	 * HMI initialization
	 */
	private void initHmi() {
		rect = new Rectangle(147, 60);
		rect.setFill(Color.BURLYWOOD);
		rect.setStroke(Color.WHITESMOKE);
		rect.setStrokeWidth(3);

		currentText = new Text(relatedItem.getWord());

		getChildren().addAll(rect, currentText);
	}

	/**
	 * Changes the displayed text
	 */
	private void switchToTranslation() {
		isTranslated = !isTranslated;
		currentText.setText(isTranslated ? relatedItem.getTranslation() : relatedItem.getWord());

		// Change color
		if (rect.getFill().equals(REGULAR_COLOR)) {
			rect.setFill(SECONDARY_COLOR);
		} else {
			rect.setFill(REGULAR_COLOR);
		}
	}

	/**
	 * CardShape controller
	 * 
	 * @author thomas
	 */
	private class CardController {
		/**
		 * Binds the clic on the card to the language switch
		 */
		private void bind() {
			currentText.setOnMouseClicked(evt -> switchToTranslation());
			rect.setOnMouseClicked(evt -> switchToTranslation());
		}
	}
}
